package top.qaqaq.crud.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import top.qaqaq.crud.bean.Department;
import top.qaqaq.crud.bean.Msg;
import top.qaqaq.crud.service.DepartmentService;

import java.util.List;

/**
 * 处理和部门有关的请求
 * @author RichieZhang
 * @create 2023-01-18 5:05 PM
 */
@Controller
public class DepartmentController {

    @Autowired
    private DepartmentService departmentService;

    /**
     * 返回所有的部门信息
     */
    @RequestMapping("/depts")
    @ResponseBody
    public Msg getDepts() {
        //查出的所有部门信息
        List<Department> list = departmentService.getDepts();
        return Msg.success().add("depts", list);
    }
}
